//+------------------------------------------------------------------+ 
//|                                                 ang_AZad_Css.mq5 | 
//|                           Copyright  2006, ANG3110@latchess.com | 
//|                                             ANG3110@latchess.com | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2006, ANG3110@latchess.com"
#property link "ANG3110@latchess.com"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----    2
#property indicator_buffers 2 
//----    
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1   DRAW_FILLING
//----     
#property indicator_color1  clrPaleGreen,clrSalmon
//----   
#property indicator_label1  "ang_AZad_Css"

//+-----------------------------------+
//|         |
//+-----------------------------------+
input double ki=2;
input int Shift=0;
input int zShift=0;
//+-----------------------------------+

//----      
int  min_rates_total;
//----   ,    
//      
double ZaBuffer[];
double Za2Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----     
   min_rates_total=4;

//----      
   SetIndexBuffer(0,ZaBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       InpKijun
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----       
   ArraySetAsSeries(ZaBuffer,true);

//----      
   SetIndexBuffer(1,Za2Buffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       -InpKijun
   PlotIndexSetInteger(1,PLOT_SHIFT,zShift);
//----       
   ArraySetAsSeries(Za2Buffer,true);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"ang_AZad_Css");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &Time[],
                const double &Open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &Tick_Volume[],
                const long &Volume[],
                const int &Spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----      
   double z,z2;
   static double z_,z2_;
//----   
   int limit;

//----         
   ArraySetAsSeries(Close,true);

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
      for(int bar=rates_total-1; bar>limit && !IsStopped(); bar--) Za2Buffer[bar]=ZaBuffer[bar]=Close[bar];
      z2_=z_=Close[limit+1];
     }
   else limit=rates_total-prev_calculated;  //       

   z=z_;
   z2=z2_;

//----    
   for(int bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      if(Close[bar]>z && Close[bar]>Close[bar+1]) z=ZaBuffer[bar+1]+(Close[bar]-ZaBuffer[bar+1])/ki;
      if(Close[bar]<z && Close[bar]<Close[bar+1]) z=ZaBuffer[bar+1]+(Close[bar]-ZaBuffer[bar+1])/ki;
      if(Close[bar]>z2 && Close[bar]<Close[bar+1]) z2=Za2Buffer[bar+1]+(Close[bar]-Za2Buffer[bar+1])/ki;
      if(Close[bar]<z2 && Close[bar]>Close[bar+1]) z2=Za2Buffer[bar+1]+(Close[bar]-Za2Buffer[bar+1])/ki;

      ZaBuffer[bar]=z;
      Za2Buffer[bar]=z2;

      if(bar)
        {
         z_=z;
         z2_=z2;
        }
     }
//----    
   return(rates_total);
  }
//+------------------------------------------------------------------+
